# $Id: distributor_forwarder.py,v 1.2 2006/03/29 12:38:34 hat Exp $
#

class Distributor_forwarder:
    """Wrapper class of Distributor to hide pipe to forwarder object"""
    def __init__(self,connection):
	self._connection=connection

	self._job_list=[]
	self._result_list=[]
	self._forwarder_needs_answer=0

    def collect_fds(self):
	#print type(self._connection)
	return ([self._connection.rhandle()],[],None)

    def handle_fds(self,inlist,outlist):
	"""Handle IO with the forwarder parent.
	   Return 1 if the distributor should quit, 0 otherwise"""
	if self._connection.rhandle() in inlist:
	    j=self._connection.recv()
	    if j==None:
		return 1    # quit
	    if j[0]=='job': # forwarder has a new job
		self._job_list.append(j[1])
		return 0    # not quit
	    if j[0]=='res': # forwarder needs results
		if len(self._result_list)>0:
		    self._connection.send(self._result_list)
		    self._result_list=[]
		    self._forwarder_needs_answer=0  # not really needed?!
		else:
		    # no jobs -> mark the program as 'waiting for results'
		    self._forwarder_needs_answer=1
		return 0
	    assert 0	# should never happen
	return 0

    #
    # Actions that the Distributor object can perform to the forwarder
    #

    def get_job(self):
	if len(self._job_list)>0:
	    j=self._job_list[0]
	    del self._job_list[0]
	    return j
	return None

    def has_job(self):
	if len(self._job_list)>0:
	    return 1
	else:
	    return 0

    def put_result(self,r):
	self._result_list.append(r)
	if self._forwarder_needs_answer==1:
	    self._connection.send(self._result_list)
	    self._result_list=[]
	    self._forwarder_needs_answer=0

