#!/usr/bin/python
# $Id: forwarder.py,v 1.3 2006/03/29 12:38:34 hat Exp $
#
import job
from general import spawn,Connection
from distributor import Distributor
from distributor_forwarder import Distributor_forwarder
import sys

class Forwarder:
    def __init__(self,factories,free_machines,logobj):
	self._factories=factories
	self._free_machines=free_machines
	self._logobj=logobj

	self.ready_jobs={}
	self.outconnect=None

	self._doconnect()   # Fork the distributor process

    def start(self,id,funcname,parms):
	_job = job.Job(id,funcname,parms)
	if self.outconnect == None:
	    self._doconnect()
	
	self.outconnect.send( ('job',_job) )
	return 1	# ok

    def answer(self,id=None):
	while 1:
	    # get the job-results of 'id', or any job-results
            if id==None and len(self.ready_jobs) > 0:
                id = self.ready_jobs.keys()[0]

            if id!=None:
                j = self.ready_jobs.get(id)
                if j!=None:
                    del self.ready_jobs[id]
                    return (id, j.job_type(), j.parameters(), j.result())

	    # not found, let's ask for new results, add them, and try again.
	    if self.outconnect == None:
		self._doconnect()
	    self.outconnect.send( ('res',) )
	    jl = self.outconnect.recv()
	    assert jl!=None
	    for j in jl:
		self.ready_jobs[j.id()]=j

    def close(self):
	self.outconnect.close()

    def _doconnect(self):
	(pid,r,w)=spawn()
	# parent
	if pid>0:
	    self.outconnect = Connection(r,w)
	    return
	# child
	assert pid == 0
	c=Connection(r,w)   # connection to the program
	#print c
	df=Distributor_forwarder(c)
	d=Distributor(df,self._factories,self._free_machines,self._logobj)
	#print "distributor started"
	try:
	    d.run()
	except KeyboardInterrupt:
	    pass
	#print "distributor ended"
	sys.exit(0)
