#!/usr/bin/python
# $Id: general.py,v 1.3 2006/03/29 12:38:34 hat Exp $
#
import pickle,os

class Connection:
    def __init__(self,r,w):
    	self.rfd = os.fdopen(r,'r',0)
    	self.wfd = os.fdopen(w,'w',0)

    def rhandle(self):
	"""Return read handle"""
    	return self.rfd

    def whandle(self):
	"""Return write handle"""
    	return self.wfd

    def send(self,data):
    	pickler=pickle.Pickler( self.wfd )
    	pickler.dump( data )
    def recv(self):
    	unpickler=pickle.Unpickler( self.rfd )
    	try:
    	    x = unpickler.load()
    	    return x
    	except EOFError:
    	    return None
    	except ValueError:
    	    return None

    def close(self):
    	self.rfd.close()
    	self.wfd.close()

#
#
#

def spawn():
    p1=os.pipe()	#(r parent, w child)
    p2=os.pipe()	#(r child, w parent)
    pid = os.fork()
    if pid>0:
	# Child of forked process
	os.close(p1[1])
	os.close(p2[0])
	return (pid,p1[0],p2[1])	# PID child, r parent, w parent
    elif pid==0:
	# Parent of forked process
	os.close(p1[0])
	os.close(p2[1])
	return (pid,p2[0],p1[1])	# 0, r child, w child
    else:
	raise "SpawnError"

