# $Id: private_machines.py,v 1.2 2003/11/13 14:51:06 hat Exp $
#
from machines import Machines

class Private_machines(Machines):
    """Machine management class that implements a 'private machine' policy.
       All machines given are assumed to be constant available for running
       computations."""

    def __init__(self,machinelist):
	Machines.__init__(self)
	self._jobcount={}	# dictionary of jobtype -> count
	self._machinejobtype={}	# dictionary of machine -> list jobtype
	self.machinelist=machinelist	# list of available machines

    def set_machines(self,jobtypedict):
	"""Set the self._jobcount and self._machinejobtype dictionaries.
	   Input is the jobtype -> list machines dictionary from the factory
	   object"""
	for jt in jobtypedict.keys():
	    self._jobcount[jt]=0
	    for mach in jobtypedict[jt]:
		jtl=self._machinejobtype.get(mach)  # jtl is list jobtypes
		if jtl==None:
		    self._machinejobtype[mach]=[jt]
		else:
		    if jt not in jtl:
			jtl.append(jt)

    def add_job(self,jobtype,cnt=1):
	if self._jobcount.has_key(jobtype):
	    self._jobcount[jobtype]=self._jobcount[jobtype]+cnt
	    return 1
	return 0

    def get_machine_jobtype(self):
	"Try to give a machine away."

	for m in self.machinelist:
	    if not self._machinejobtype.has_key(m):
		continue    # we cannot do anything with this machine
	    # for machine m, try all jobtypes it can handle
	    for jt in self._machinejobtype[m]:
		assert(self._jobcount.has_key(jt))
		if self._jobcount[jt]>0:
		    # found a match: update the internal structures, and return
		    # the tuple
		    self._jobcount[jt]=self._jobcount[jt]-1
		    self.machinelist.remove(m)
		    return (m,jt)
	return None # no match found.

    def give_machine(self,m):
	self.machinelist.append(m)

